// @(#)DrawDocument.h	2.21	10/29/91

#ifndef DrawDocument_First

#ifdef __GNUG__
#pragma once
#endif

#define DrawDocument_First

#include "Document.h"
#include "Dialog.h"

#ifdef ET23
extern Symbol cDocTypeDraw;
#else
extern char *cDocTypeDraw;
#endif


extern int	geo_version,
		cur_geo_version;

extern bool	GEOBROWSE;


class InfoDialog: public Dialog {
  friend class DrawDocument;
  class TextItem		*infolong, *infolat, *infolength;
  class EditTextItem		*infoname;
  class DrawDocument		*drawDocument;
  class Shape			*infoShape;

public:
  MetaDef(InfoDialog);

  InfoDialog(class DrawDocument *, char *name);
  VObject *DoCreateDialog();
  void Control(int id, int part, void *val);
};

class DrawDocument : public Document {
    friend InfoDialog;

    class ObjArray		*prototypes;
    class ObjList		*tools;
    class VObject		*paletteFrame, *vop, *vop1;
    class DrawView		*drawView;
    class DrawController	*drawController;
    class OverView		*overView;
    class ColorView		*colorview;
    class CollectionView	*paletteView;
    class ObjList		*shapes;
    class Shape			*textPrototype;
    class TextItem		*info;
    class InfoDialog		*infoDialog;
    class Geo			*geo;
    class MenuBar		*mb;
    class Window		*overwindow;
    class MessageView		*mv;

    void LoadGeo(char *);
    void LoadGeoDone();
    bool LoadMap(istream &);
    void InitCS();
public:
    MetaDef(DrawDocument);
    
    DrawDocument(ObjArray*, ObjList*);
    ~DrawDocument();

    Window *DoMakeWindows();
    void DoMakeInfo();
    Command *DoMenuCommand(int cmd);
    class MenuBar *CreateMenuBar();
    void DoRead(istream &from, FileType *type);
    void DoWrite(ostream &from, int opt);
    bool CanLoadDocument(FileType *);
    bool CanImportDocument(class FileType *ft);
    Command *DoImport(istream &, class FileType *ft);
    void Control(int id, int part, void *val);

    void ShowInfo(class Shape *);
    void SetMessage(char *m);

    void HourOn();
    void HourOff();

    class ObjArray *GetPrototypes() { return prototypes; }
#if 0
    Command *DoIdleCommand();
#endif
};

#endif DrawDocument_First

