# line 1 "IngresSql.h.sc"	
#ifndef IngresSql_first
#define IngresSql_first

#include "IO/stream.h"

#define  NAME_MAX       15
#define  STMT_MAX       50
#define  SQLDA_VARS     10

#ifndef NO_INGRES
# include "/u/tnosoes/Ingres6/ingres/files/eqsqlda.h"
#endif

void IgnoreSqlError(unsigned n);
int SqlErrorsLeft();

//--- IngresSql ---------------------------------------------------------------

enum eFieldType { cUndefinedType, cStrType, cVStrType, cCharType, cShortType, 
		  cLongType, cFloatType, cDoubleType };


struct Sql_Field 
{
    char       *name;
    eFieldType type;
    int        length; 		// only for type 'c(V)StrType'
    union {
	char   *strval;
	char   charval;
	short  shortval;
	long   longval;
	float  floatval;
	double doubleval;
    };
};

class IngresSql {
	char *dbname;
public:
	IngresSql( char* );
	~IngresSql();

	char* GetDbName();
	void CreateTable( char* tabname, Sql_Field* fs, int fs_size );
	void Insert( char* tabname, Sql_Field* fs, int fs_size ); 
	void DropTable( char* tabname );
};


//--- IngresSqlSelect ---------------------------------------------------------

enum eIngresMode { cNormalMode, cWriteMode, cReadMode };


class IngresSqlSelect {
        IISQLDA *sqlda;
	char *tablename;
	char *wherestr;
	int  wherematch=-1;	// Number of records matching 'wherestr'
				// NOTE: valid after call 'GetFieldCnt'
	eIngresMode ingresmode;
	FILE *ingfp;
	int Bad;
protected:
	char crsr[10];
public:
	IngresSqlSelect( char*, char* = NULL, char* = "*", eIngresMode = cNormalMode,
			 char* = "ingres.select");
		// The last field specifies and 'special' operation!
		// =cNormalMode    nothing special just
		//		   select data from ingres SLOW!
		// =cWriteMode     records selected data also in
		//                 a files, with the name "ingres.select"
		// =cReadMode      selected data are not extracted from
		//                 ingres but from a file called "ingres.select"

	~IngresSqlSelect();

	int operator()();

	void ShowSqlda();
	int GetRecordCnt();

	int GetFieldCnt()
#ifndef NO_INGRES
		{ return (int)sqlda->sqld; }
#else
		{ return 0; }
#endif
	eFieldType GetFieldType( int );
	eFieldType GetFieldType( char* );
	void* GetFieldValue( int );
	void* GetFieldValue( char* );
	int GetFieldSize( int );
	int GetFieldSize( char* );
	int IsBad() { return Bad; }
};

#endif
